%%%%% CREATE PARAMETER DISTRIBUTION %%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


if directdraw==0
    
    %%% local approximation of posterior
    if par.localapp==1; ComputeH; end %% Compute Hessian
    
    %%% MCMC sampling
    %%%% initial sample states
    for j3=1:nchain
        initstate(j3,:)= (a0+0.001*randn(size(a0,1),1))';
    end
    
    % generate 10*n initial samples, with n the number of parameters
    if initialsampling==0        
        % by random sampling
        Z=initstate(1,:).*(1+0.001*randn(1,n));
        for j=1:10*n
            Z=[Z; initstate(1,:).*(1+0.001*randn(1,n))];
        end
    elseif initialsampling==1        
        % by sampling from normal distribution with covariance matrix H^-1
        ComputeH;
        Hinv=inv(par.H);
        R = chol(2*Hinv);
        Z=zeros(10*n,n);
        j=1;
        while j<10*n %for i=1:nsample %% number of samples
            prop = a0'+ randn(1,n)*R;
            if (sum(prop'>par.lb)==n && sum(prop'<par.ub)==n)
                Z(j,:)=prop; j=j+1;
            end
        end
        
    end
    
    %%% choose blockindex
    %% example: blockindex{1} = 1:4; blockindex{2} = 5:n;
    %% for 2 blocks, one for parameters 1-4 and one for parameters 5-n
    blockindex = {1:n};  %% default
    
    %%% sample states
    [states, accept, logprob, R, iterations]=DEMCz(@(a0)logposterior(a0,par),...
        initstate, Z, nit,nthin,blockindex,[],[],[],[]);
    
    %% discard burn-in states
    states(1:bi,:)=[];
    logprob(1:bi)=[];
    
elseif directdraw==1  %% direct draws via Hessian matrix
    
    ComputeH;
    Hinv=inv(par.H);
    R = chol(2*Hinv);
    states_s=zeros(nsample,n);
    j=1;
    while j<nsample %for i=1:nsample %% number of samples
        prop = a0'+ randn(1,n)*R;
        if (sum(prop'>par.lb)==n && sum(prop'<par.ub)==n)
            states_s(j,:)=prop; j=j+1;
        end
    end
    states=states_s;
    
end

