function f=functionf(t,x,flag,a, par)


model=par.model;
%% transform parameter back to linear space
a=backtransform(a);


if par.preddynamics==1 && model~=1 %% for model 1, the parameters stay the same
    %% alterations made to the dynamics, for example by setting a
    %% parameter to zero (e.g., a gene knockout)
    %     if pred==1; a(1)=a(1)*1e-2;  end
    %     if pred==2; a(2)=0; end  %% etc..
    
    %%% here we use a systematic perturbation
    pred=par.predictionnumber;
    f1=1e-2; f2=1e2;
    if pred<= length(a);
        a(pred)=f1*a(pred);
    else
        a(pred-length(a))=f2*a(pred-length(a));
    end
    
end

if model==1  %% Monod
    if par.preddynamics==0; u=par.u1;
    elseif par.preddynamics==1; u=par.u2;
    end
    f=10*x^2/(a(1)+x^2)-a(2)*x+u*x*sin(t);
elseif model==2 %% Laub-Loomis
    LaubLoomis
elseif model==3 %% Levchenko
    Levchenko
elseif model==4 %% Goldbeter
    Goldbeter
elseif model==5 %% Tyson
    Tyson1
elseif model==6 %% Vilar
    Vilar
elseif model==7 %% Leloup
    Leloup
end



function z = pow (x, y)
z = x^y;


function z = sqr (x)
z = x*x;


function z = piecewise(varargin)
numArgs = nargin;
result = 0;
foundResult = 0;
for k=1:2: numArgs-1
    if varargin{k+1} == 1
        result = varargin{k};
        foundResult = 1;
        break;
    end
end
if foundResult == 0
    result = varargin{numArgs};
end
z = result;


function z = gt(a,b)
if a > b
    z = 1;
else
    z = 0;
end


function z = lt(a,b)
if a < b
    z = 1;
else
    z = 0;
end


function z = geq(a,b)
if a >= b
    z = 1;
else
    z = 0;
end


function z = leq(a,b)
if a <= b
    z = 1;
else
    z = 0;
end


function z = neq(a,b)
if a ~= b
    z = 1;
else
    z = 0;
end


function z = and(varargin)
result = 1;
for k=1:nargin
    if varargin{k} ~= 1
        result = 0;
        break;
    end
end
z = result;


function z = or(varargin)
result = 0;
for k=1:nargin
    if varargin{k} ~= 0
        result = 1;
        break;
    end
end
z = result;


function z = xor(varargin)
foundZero = 0;
foundOne = 0;
for k = 1:nargin
    if varargin{k} == 0
        foundZero = 1;
    else
        foundOne = 1;
    end
end
if foundZero && foundOne
    z = 1;
else
    z = 0;
end



function z = not(a)
if a == 1
    z = 0;
else
    z = 1;
end


function z = root(a,b)
z = a^(1/b);




