function [logpost flagint]=logposterior(a,par)

%%% computes the log-likelihood of a parameter vector

localapp=par.localapp;
a0=par.a0;
x0=par.x0;
sig=par.sig;

%%%%% compute log-posterior
if localapp==1  %%% local chi2 approximation
    a=a';
    loglikelihood=-0.5*0.5*(a-a0)'*par.H*(a-a0);
else   %%% time integrations
    a=a';
    [time,Y]=makeY(a,x0,par);
    
    flagint=0;
    if sum(size(Y)==size(par.Y0))~=2
        Y=1e-8*ones(size(par.Y0));
        disp('integration failed!'); flagint=1;
    end
    
    eps=(Y-par.Y0)./sig;
    eps2=-0.5*sum(sum(eps.^2)); %% -0.5 is for DE-MC, which
    %% uses the log-probability
    
    loglikelihood=eps2;
    
end

%%%%% compute log-prior
if sum(a>par.lb)==length(a) && sum(a<par.ub)==length(a) %% proposal inside [lb,ub]
    logprior=1; %uniform
else %% proposal outside [lb,ub]
    logprior=-inf;
end

%%%%% compute log-posterior
logpost=logprior+loglikelihood;


